src/Entity/Media.php
<?php

namespace App\Entity;

use App\Repository\MediaRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;


#[ORM\Entity(repositoryClass: MediaRepository::class)]
class Media
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    private $image;

    #[ORM\Column(type: 'string', length: 255, nullable: true)]
    #[Assert\File(
        maxSize: '100M')]
    private $video;

    #[ORM\Column(type: 'boolean', nullable: true)]
    private $visibilite_med;

    #[ORM\Column(type: 'string', length: 25, nullable: true)]
    private $categorie;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getImage(): ?string
    {
        return $this->image;
    }

    public function setImage(?string $image): self
    {
        $this->image = $image;

        return $this;
    }

    public function getVideo(): ?string
    {
        return $this->video;
    }

    public function setVideo(?string $video): self
    {
        $this->video = $video;

        return $this;
    }

    public function getVisibiliteMed(): ?bool
    {
        return $this->visibilite_med;
    }

    public function setVisibiliteMed(?bool $visibilite_med): self
    {
        $this->visibilite_med = $visibilite_med;

        return $this;
    }

    public function getCategorie(): ?string
    {
        return $this->categorie;
    }

    public function setCategorie(?string $categorie): self
    {
        $this->categorie = $categorie;

        return $this;
    }
}

src/Form/MediaType.php
<?php

namespace App\Form;

use App\Entity\Media;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use App\Service\FileUploader;
use Symfony\Component\Form\Extension\Core\Type\FileType;

class MediaType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('image', FileType::class,[
                'mapped'=> false
            ])
            ->add('video', FileType::class, [
                'mapped'=> false,
            ])
            ->add('visibilite_med')
            ->add('categorie')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Media::class,
        ]);
    }
}

src/Controller/MediaController.php
<?php

namespace App\Controller;

use App\Entity\Media;
use App\Form\MediaType;
use App\Repository\MediaRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Service\FileUploader;

#[Route('/media')]
class MediaController extends AbstractController
{
    #[Route('/', name: 'app_media_index', methods: ['GET'])]
    public function index(MediaRepository $mediaRepository): Response
    {
        return $this->render('media/index.html.twig', [
            'media' => $mediaRepository->findAll(),
        ]);
    }
   
    #[Route('/new', name: 'app_media_new', methods: ['GET', 'POST'])]
    public function new(Request $request, FileUploader $fileUploader, MediaRepository $mediaRepository): Response
    {
        //Image et video upload
        $medium = new Media();
        $form = $this->createForm(MediaType::class, $medium);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $imageFile = $form->get('image')->getData();
            $videoFile = $form->get('video')->getData();
        if ($imageFile && $videoFile) {
            $videoFileName = $fileUploader->upload($videoFile);
            $imageFileName = $fileUploader->upload($imageFile);

            $medium->setImage($imageFileName);
            $medium->setVideo($videoFileName);
        }
            $mediaRepository->add($medium);
            return $this->redirectToRoute('app_media_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('media/new.html.twig', [
            'medium' => $medium,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_media_show', methods: ['GET'])]
    public function show(Media $medium): Response
    {
        return $this->render('media/show.html.twig', [
            'medium' => $medium,
        ]);
    }

    #[Route('/{id}/edit', name: 'app_media_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, Media $medium, MediaRepository $mediaRepository): Response
    {
        $form = $this->createForm(MediaType::class, $medium);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $mediaRepository->add($medium);
            return $this->redirectToRoute('app_media_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('media/edit.html.twig', [
            'medium' => $medium,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_media_delete', methods: ['POST'])]
    public function delete(Request $request, Media $medium, MediaRepository $mediaRepository): Response
    {
        if ($this->isCsrfTokenValid('delete'.$medium->getId(), $request->request->get('_token'))) {
            $mediaRepository->remove($medium);
        }

        return $this->redirectToRoute('app_media_index', [], Response::HTTP_SEE_OTHER);
    }
}

templates/media/_delete_form.html.twig
<form method="post" action="{{ path('app_media_delete', {'id': medium.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ medium.id) }}">
    <button class="btn">Delete</button>
</form>

templates/media/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/media/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Media{% endblock %}

{% block body %}
    <h1>Edit Media</h1>

    {{ include('media/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('app_media_index') }}">back to list</a>

    {{ include('media/_delete_form.html.twig') }}
{% endblock %}

templates/media/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Media index{% endblock %}

{% block body %}

    {{ include('header/index.html.twig') }}

    {# <h1>Media index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Image</th>
                <th>Video</th>
                <th>Visibilite_med</th>
                <th>Categorie</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for medium in media %}
            <tr>
                <td>{{ medium.id }}</td>
                <td>{{ medium.image }}</td>
                <td>{{ medium.video }}</td>
                <td>{{ medium.visibiliteMed ? 'Yes' : 'No' }}</td>
                <td>{{ medium.categorie }}</td>
                <td>
                    <a href="{{ path('app_media_show', {'id': medium.id}) }}">show</a>
                    <a href="{{ path('app_media_edit', {'id': medium.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="6">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_media_new') }}">Create new</a> #}

    <main id="bodygalerie">
        <h2 class="h1">Galerie Photos et Vidéos</h2>
        <div class="mesphotos">
            {% for medium in media %}
                <img class="imagesbdd" src="/uploads/{{ medium.image }}" alt="photofilm">
                <video controls width="250">
                    <source src="/uploads/{{ medium.video }}"
                            type="video/webm">
                    <source src="/uploads/{{ medium.video }}"
                            type="video/mp4">
                    Sorry, your browser doesn't support embedded videos.
                </video>
            {% else %}
                <p>Aucune photos ou video n'est disponible</p>
            {% endfor %}
        </div>

        <div class="separation">
            <img class="separe" src="/images/lames.png" alt="lames">
        </div>

    <div id="mesvideos">
        {# <?php




        $resultat = PrendreVideosVisibles();

        ?> #}



        {# <?php
        foreach ($resultat as $i) {
        ?> #}
            <div id="chaquevideo">
                test ici video
            </div>
        {# <?php } ?> #}

    </div>

    </main>

    {{ include('footer/index.html.twig') }}

{% endblock %}

templates/media/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Media{% endblock %}

{% block body %}
    <h1>Create new Media</h1>

    {{ include('media/_form.html.twig') }}

    <a href="{{ path('app_media_index') }}">back to list</a>
{% endblock %}

templates/media/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Media{% endblock %}

{% block body %}
    <h1>Media</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ medium.id }}</td>
            </tr>
            <tr>
                <th>Image</th>
                <td>{{ medium.image }}</td>
            </tr>
            <tr>
                <th>Video</th>
                <td>{{ medium.video }}</td>
            </tr>
            <tr>
                <th>Visibilite_med</th>
                <td>{{ medium.visibiliteMed ? 'Yes' : 'No' }}</td>
            </tr>
            <tr>
                <th>Categorie</th>
                <td>{{ medium.categorie }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_media_index') }}">back to list</a>

    <a href="{{ path('app_media_edit', {'id': medium.id}) }}">edit</a>

    {{ include('media/_delete_form.html.twig') }}
{% endblock %}